diff -r 82fcd4bea972 src/ha.c
--- a/src/ha.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/ha.c	Fri Jan 11 17:02:25 2008 +0100
@@ -59,6 +59,14 @@
 #include "xfrm.h"
 #include "ndisc.h"
 #include "prefix.h"
+
+#define HA_DEBUG_LEVEL 1
+
+#if HA_DEBUG_LEVEL >= 1
+#define MDBG dbg
+#else 
+#define MDBG(...) 
+#endif /* MDBG */
 
 static pthread_mutex_t bu_worker_mutex;
 static volatile unsigned long bu_worker_count = 0;
@@ -504,7 +512,7 @@ static int ha_vt_init(void)
 
 static void nemo_ha_del_mnp_routes(struct list_head *old_mnps,
 				   struct list_head *new_mnps,
-				   int ifindex, int all)
+				   int table, int ifindex, int all)
 {
 	struct list_head *list;
 	list_for_each(list, old_mnps) {
@@ -514,14 +522,22 @@ static void nemo_ha_del_mnp_routes(struc
 		    prefix_list_find(new_mnps, &p->ple_prefix, p->ple_plen))
 			continue;
 
-		route_del(ifindex, RT6_TABLE_MIP6, IP6_RT_PRIO_MIP6_FWD,
+		route_del(ifindex, table, IP6_RT_PRIO_MIP6_FWD,
 			  NULL, 0, &p->ple_prefix, p->ple_plen, NULL);
+
+		/* MCoA
+		 * Delete the MNP fwmark rule
+		 */
+		if(table != RT6_TABLE_MIP6)
+			rule_del(NULL, table, IP6_RULE_PRIO_MIP6_FWD_FWM, 
+				 table, RTN_UNICAST, &in6addr_any, 0, 
+			 	 &p->ple_prefix, p->ple_plen, 0);
 	}
 }
 
 static int nemo_ha_add_mnp_routes(struct list_head *old_mnps,
 				  struct list_head *new_mnps,
-				  int ifindex, int all)
+				  int table, int ifindex, int all)
 {
 	struct list_head *list;
 	list_for_each(list, new_mnps) {
@@ -530,11 +546,89 @@ static int nemo_ha_add_mnp_routes(struct
 		if (!all &&
 		    prefix_list_find(old_mnps, &p->ple_prefix, p->ple_plen))
 			continue;
-		if (route_add(ifindex, RT6_TABLE_MIP6, RTPROT_MIP,
+		if (route_add(ifindex, table, RTPROT_MIP,
 			      0, IP6_RT_PRIO_MIP6_FWD,
 			      NULL, 0, &p->ple_prefix, p->ple_plen, NULL) < 0)
 			return -1;
+		/* MCoA
+		 * Add the MNP fwmark rule
+		 */
+		if(table != RT6_TABLE_MIP6
+		   && rule_add(NULL, table, IP6_RULE_PRIO_MIP6_FWD_FWM, 
+			       table, RTN_UNICAST, &in6addr_any, 0, 
+			       &p->ple_prefix, p->ple_plen, 0) < 0)
+			return -1;
 	}
+	return 0;
+}
+
+static int mcoa_ha_init_rt_table(struct bcentry *bce)
+{
+	/* MCoA TODO2
+	 * At the moment, the routing table number is the BID number. 
+	 * BID thus must be between BCE_TABLE_MIN and BCE_TABLE_MAX
+	 */
+	assert(bce);
+
+	/* If BID is not assigned, default table is taken */
+	if (!bce->bid)
+		return (bce->table = RT6_TABLE_MIP6);
+	
+	if (bce->bid >= BCE_TABLE_MIN && bce->bid <= BCE_TABLE_MAX)
+		return (bce->table = bce->bid);
+
+	return -1;
+}
+
+static int mcoa_ha_del_dflt_rules(struct bcentry *bce)
+{
+	struct list_head *list;
+	struct prefix_list_entry *pfx;
+	struct bcentry *best_bce = bce;
+	const struct in6_addr *peer_addr = &bce->peer_addr;
+	int8_t priority = 0;
+	
+	MDBG("Current BCE has the best priority (%d), "
+	     "erasing default rules\n", best_bce->priority);
+	
+	/* Erase the default HoA rule */
+	rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, 
+		RTN_UNICAST, &in6addr_any, 0, peer_addr, 128, 0);
+	
+	/* Erase the default MNP rules */
+	list_for_each(list, &bce->mob_net_prefixes) {
+		pfx = list_entry(list, struct prefix_list_entry, list);
+		rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, 
+			RTN_UNICAST, &in6addr_any, 0, 
+			&pfx->ple_prefix, pfx->ple_plen, 0);
+	}
+		
+	/* Create new rule with next best bce available */
+	priority = bce->priority;
+	bce->priority = 0;
+	bcache_iterate_in(&bce->peer_addr, bce_highest_priority, 
+			&best_bce);
+	bce->priority = priority;
+	
+	if(best_bce != bce) {
+		MDBG("Rules replaced with BCE prio %d\n", 
+			best_bce->priority);
+		rule_add(NULL, best_bce->table, 
+			IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, RTN_UNICAST, 
+			&in6addr_any, 0, peer_addr, 128, 0);
+				
+		/* Default prefix rules */		
+		list_for_each(list, &bce->mob_net_prefixes) {
+			pfx = list_entry(list, 
+				struct prefix_list_entry, list);
+		   	rule_add(NULL, best_bce->table, 
+				IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, 
+				RTN_UNICAST, &in6addr_any, 0, 
+				&pfx->ple_prefix, pfx->ple_plen, 0);
+		}
+	} else
+		MDBG("No other BCE available, no dflt rules added\n");
+
 	return 0;
 }
 
@@ -544,10 +638,49 @@ struct home_tnl_ops_parm {
 	struct list_head mob_net_prefixes;
 };
 
+static int mcoa_ha_add_dflt_rules(struct home_tnl_ops_parm *p)
+{
+	struct list_head *list;
+	struct bcentry *bce = p->bce;
+	const struct in6_addr *peer_addr = &bce->peer_addr;
+	
+	MDBG("BCE has the best priority (%d), adding default HoA "
+		"and prefix rules\n", bce->priority);
+	
+	/* Erase the default HoA rule */
+	rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, 
+		RTN_UNICAST, &in6addr_any, 0, peer_addr, 128, 0);
+	
+	/* Add the default HoA rule */
+	if (rule_add(NULL, bce->table,
+			IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, RTN_UNICAST,
+			&in6addr_any, 0, peer_addr, 128, 0) < 0)
+		return -1;
+	
+	/* Delete and add the default prefix rules */
+	list_for_each(list, &p->mob_net_prefixes) {
+		struct prefix_list_entry *pfx;
+		pfx = list_entry(list, struct prefix_list_entry, list);
+		
+		rule_del(NULL, 0, IP6_RULE_PRIO_MIP6_FWD_MCOA, 
+			0, RTN_UNICAST, &in6addr_any, 0, 
+			&pfx->ple_prefix, pfx->ple_plen, 0);
+		
+		if (rule_add(NULL, bce->table, 
+				IP6_RULE_PRIO_MIP6_FWD_MCOA, 0, 
+				RTN_UNICAST, &in6addr_any, 0, 
+				&pfx->ple_prefix, pfx->ple_plen, 0) < 0)
+			return -1;
+	}
+	
+	return 0;
+}
+
 static int home_tnl_del(int old_if, int new_if, struct home_tnl_ops_parm *p)
 {
 	const struct in6_addr *our_addr, *peer_addr, *coa, *old_coa;
 	struct list_head *mnp;
+	struct bcentry *best_bce = NULL;
 
 	assert(old_if);
 
@@ -565,12 +698,33 @@ static int home_tnl_del(int old_if, int 
 		ha_ipsec_tnl_pol_del(our_addr, peer_addr, p->bce->tunnel, mnp);
 	}
 	/* delete HoA route */
+	/* MCoA: The route is deleted in the table given by p->bce->table */
+	/* RKRK: for the moment the route is installed in the MAIN table. 
+	 * See home_tnl_add */
+	//MDBG("Deleting old default route in table %d\n", p->bce->table);
+	MDBG("Deleting old default route in table %d\n", RT6_TABLE_MAIN);
+	//route_del(old_if, p->bce->table,
 	route_del(old_if, RT6_TABLE_MAIN,
 		  IP6_RT_PRIO_MIP6_FWD, NULL, 0, peer_addr, 128, NULL);
-
+ 
 	/* delete MNP routes */
 	nemo_ha_del_mnp_routes(&p->bce->mob_net_prefixes,
-			       &p->mob_net_prefixes, old_if, 1);
+			       &p->mob_net_prefixes, p->bce->table, 
+			       old_if, 1);
+	/* MCoA 
+	 * Delete the HoA and fwmark rules, and if needed replace 
+	 * the default HoA and MNP rules with the best available one
+	 */
+	if(p->bce->table != RT6_TABLE_MIP6) {
+		rule_del(NULL, p->bce->table, IP6_RULE_PRIO_MIP6_FWD_FWM,
+			 p->bce->table, RTN_UNICAST, &in6addr_any, 0, 
+			 peer_addr, 128, 0);
+		best_bce = p->bce;
+		bcache_iterate_in(&p->bce->peer_addr, 
+				  bce_highest_priority, &best_bce);
+		if(best_bce == p->bce)
+			mcoa_ha_del_dflt_rules(p->bce);
+	}
 	/* update tunnel interface */
 	p->bce->tunnel = new_if;
 
@@ -581,6 +735,7 @@ static int home_tnl_add(int old_if, int 
 {
 	const struct in6_addr *our_addr, *peer_addr, *coa, *old_coa;
 	struct list_head *mnp;
+	struct bcentry *best_bce = NULL;
 
 	assert(new_if);
 
@@ -596,7 +751,8 @@ static int home_tnl_add(int old_if, int 
 
 	/* add MNP routes */
 	if (nemo_ha_add_mnp_routes(&p->bce->mob_net_prefixes,
-				   &p->mob_net_prefixes, new_if, 1) < 0) {
+				   &p->mob_net_prefixes, p->bce->table, 
+				   new_if, 1) < 0) {
 		if (p->bce->nemo_type == BCE_NEMO_EXPLICIT)
 			p->ba_status = IP6_MH_BAS_INVAL_PRFX;
 		else
@@ -604,11 +760,38 @@ static int home_tnl_add(int old_if, int 
 		goto err;
 	}
 	/* add HoA route */
+	/* MCoA: The route is added in the table given by p->bce->table */
+	/* RKRK: does not work. Route has to be added in the MAIN table.
+	 * Need to check why! */
+	//MDBG("Adding route in table %d via iface %d\n", p->bce->table, new_if);
+	MDBG("Adding route in table %d via iface %d\n", RT6_TABLE_MAIN, new_if);
+	//if (route_add(new_if, p->bce->table,
 	if (route_add(new_if, RT6_TABLE_MAIN,
 		      RTPROT_MIP, 0, IP6_RT_PRIO_MIP6_FWD,
 		      NULL, 0, peer_addr, 128, NULL) < 0) {
 		p->ba_status = IP6_MH_BAS_INSUFFICIENT;
 		goto err;
+	}
+	/* MCoA
+	 * Add the HoA and fwmark rules, and if needed replace 
+	 * the default HoA and MNP rules with the best available one
+	 */
+	if (p->bce->table != RT6_TABLE_MIP6) {
+		if (rule_add(NULL, p->bce->table,
+			     IP6_RULE_PRIO_MIP6_FWD_FWM, 
+			     p->bce->table, RTN_UNICAST,
+		     	     &in6addr_any, 0, peer_addr, 128, 0) < 0) {
+			p->ba_status = IP6_MH_BAS_INSUFFICIENT;
+			goto err;
+		}
+		best_bce = p->bce; 
+		bcache_iterate_in(&p->bce->peer_addr, 
+				bce_highest_priority, &best_bce);
+		if(best_bce == p->bce 
+		   && mcoa_ha_add_dflt_rules(p) < 0) {
+			p->ba_status = IP6_MH_BAS_INSUFFICIENT;
+			goto err;
+		}
 	}
 	/* add SP entry */	
 	if (conf.UseMnHaIPsec) {
@@ -664,9 +847,11 @@ static int home_tnl_chg(int old_if, int 
 			/* Do the same for routes */
 			nemo_ha_del_mnp_routes(&p->bce->mob_net_prefixes,
 					       &p->mob_net_prefixes,
+					       p->bce->table,
 					       old_if, 0);
 			if (nemo_ha_add_mnp_routes(&p->bce->mob_net_prefixes,
 						   &p->mob_net_prefixes,
+						   p->bce->table,
 						   new_if, 0) < 0) {
 				if (p->bce->nemo_type == BCE_NEMO_EXPLICIT)
 					p->ba_status = IP6_MH_BAS_INVAL_PRFX;
@@ -707,12 +892,22 @@ static int home_tnl_ops(int request, int
 
 static void home_cleanup(struct bcentry *bce)
 {
-	mpd_cancel_mpa(&bce->our_addr, &bce->peer_addr);
+	int nb_entry = mcoa_bce_count(&bce->peer_addr);
+
+	/* MCoA 
+	 * MPA is canceled if this is the last BCE entry
+	 */
+	if (nb_entry == 1)
+		mpd_cancel_mpa(&bce->our_addr, &bce->peer_addr);
 
 	if (bce->link > 0) {
-		route_del(bce->link, RT6_TABLE_MIP6, IP6_RT_PRIO_MIP6_OUT,
+		route_del(bce->link, bce->table, IP6_RT_PRIO_MIP6_OUT,
 			  &bce->our_addr, 128, &bce->peer_addr, 128, NULL);
-		proxy_nd_stop(bce->link, &bce->peer_addr, bce->flags);
+		/* MCoA
+		 * Proxy ND is stopped if this is the last BCE entry
+		 */
+		if (nb_entry == 1)
+			proxy_nd_stop(bce->link, &bce->peer_addr, bce->flags);
 	}
 	if (bce->tunnel > 0) {
 		struct home_tnl_ops_parm p = {
@@ -724,6 +919,9 @@ static void home_cleanup(struct bcentry 
 	if (conf.UseMnHaIPsec) {
 		ha_mn_ipsec_pol_mod(&bce->our_addr, &bce->peer_addr);
 	}
+
+	/* MCoA: Freeing the BCE's MNPs list */
+	prefix_list_free(&bce->mob_net_prefixes);
 }
 
 
@@ -800,19 +998,28 @@ static void *ha_recv_bu_worker(void *var
 {
 	struct ha_recv_bu_args *arg = varg;
 	struct in6_addr_bundle out;
-	struct bcentry *bce;
+	struct bcentry *bce, *bce_exists;
 	struct timespec lft, tmp;
-	int iif, status, new, home_ifindex;
-	uint16_t bu_flags, seqno;
-	uint8_t ba_flags;
+	int iif, status, status_bid, new, home_ifindex;
+	int update_dflt_table;
+	uint16_t bu_flags, seqno, bid;
+	uint8_t ba_flags, bid_priority, bid_flags;
 	struct home_tnl_ops_parm p;
+	struct ip6_mh_opt_bid *bid_opt;	
 
 	pthread_dbg("thread started");
 restart:	
 	home_ifindex = 0;
 	new = 0;
+	bid = 0; 
+	bid_priority = 0;
+	bid_flags = 0;
+	update_dflt_table = 0;
 	ba_flags = 0;
-	lft = arg->lft;
+	status = IP6_MH_BAS_UNSPECIFIED;
+	status_bid = 0;
+	bce = NULL;
+ 	lft = arg->lft;
 	iif = arg->iif;
 	bu_flags = arg->bu->ip6mhbu_flags;
 	seqno = ntohs(arg->bu->ip6mhbu_seqno);
@@ -827,8 +1034,79 @@ restart:
 	else
 		out.bind_coa = NULL;
 	out.local_coa = NULL;
+	bid_opt = NULL;
 
-	bce = bcache_get(out.src, out.dst);
+	/* MCoA
+	 * We check if a BCE already exists for this HoA 
+	 * We take the first one available 
+	 */
+	bce_exists = bcache_get(out.src, out.dst, MCOA_NO_BID);	
+	if(bce_exists)
+		bcache_release_entry(bce_exists);
+
+	/* MCoA
+	 * we need the BID before looking at the BCE 
+	 */
+	bid_opt = mh_opt(&arg->bu->ip6mhbu_hdr, 
+			&arg->mh_opts, 
+			IP6_MHOPT_BID);
+
+	if (bid_opt && !default_mcoa_reg(out.dst)) {
+		/* MCoA: BAck without BID option will be sent */
+		MDBG("BUI option, but MCoA registration not allowed.\n");
+	} else if (bid_opt) {
+		MDBG("BUI option, and HA is configured for MCoA.\n");
+		bid = ntohs(bid_opt->ip6mobid_bid);
+		bid_priority = bid_opt->ip6mobid_priority;
+		bid_flags = ntohs(bid_opt->ip6mobid_reserved);
+		
+		if (!bid) {
+			MDBG("BID invalid, BU discarded.\n");
+			goto out;
+		}
+		
+		MDBG("BID = %d, Priority = %d\n", bid, bid_priority);
+		/* MCoA TODO1
+		 * if B flag is set but no altcoa option: 
+		 * BAck status 145.
+		 * To update according to latest draft.
+		 */
+		if (bid_flags & IP6_OPT_BID_BULK) {
+			/* MCoA TODO1
+		 	* At the moment we do not check the AltCoA option, 
+		 	* and just reject the BU if B flag is set
+		 	*/
+			MDBG("BULK Reg., but not supported yet.\n");
+				status = IP6_MH_BAS_MCOA_BULK_FAILED;
+				goto send_nack;
+		}
+		if (bce_exists && !bce_exists->bid) {
+			/* MCoA 
+			 * The BCE has a BID = 0, this means no MCoA 
+			 * are registered. We delete the entry and set 
+			 * BA status to 144. 
+			 * New registratration is done later
+			 */
+			MDBG("BID option but BCE has no BID\n");
+			MDBG("Delete BCE and register new one.\n");
+			bcache_delete(out.src, out.dst, MCOA_NO_BID);				
+			status_bid = IP6_MH_BAS_CONFLICT_BINDING;
+		}							
+	} else /* No BUI option in BU */ {
+		if(tsisset(lft) && bce_exists && bce_exists->bid) {
+			/* MCoA
+			 * A BCE exists with a BID != 0 but no BUI 
+			 * sub-option are set in the BU: we delete 
+			 * all existing entries for this HoA. New 
+			 * registration is done later.
+			 */
+			MDBG("No BID option but BCE has BID.\n");
+			MDBG("Delete all BCE and register new one.\n");
+			bcache_delete(out.src, out.dst, MCOA_NO_BID);
+		}
+	}
+	
+	bce = bcache_get(out.src, out.dst, bid);
 	if (bce) {
 		if (bce->type != BCE_NONCE_BLOCK) {
 			/* H-bit or R-bit mismatch, flags changed */
@@ -873,7 +1151,7 @@ restart:
 				goto send_nack;
 			}
 			/* else get rid of it */
-			bcache_delete(out.src, out.dst);
+			bcache_delete(out.src, out.dst, bid);			
 		}
 	} else if (!tsisset(lft)) {
 		status = IP6_MH_BAS_NOT_HA;
@@ -895,6 +1173,10 @@ restart:
 					   out.src, arg->bu, arg->len);
 	if (status >= IP6_MH_BAS_UNSPECIFIED)
 		goto send_nack;
+
+	if(status_bid)
+		status = status_bid;
+
 	/* lifetime may be further decreased by local policy */
 	if (conf.pmgr.max_binding_life(out.dst, out.bind_coa, out.src,
 				       arg->bu, arg->len, &lft, &tmp)) {
@@ -916,24 +1198,38 @@ restart:
 		bce->type = BCE_DAD;
 		bce->cleanup = NULL;
 		bce->link = home_ifindex;
-
+		bce->bid = bid;
+		bce->priority = bid_priority;
+		if(bce_exists)
+			bce->xfrm_create = 0;
+		else
+			bce->xfrm_create = 1;
+ 
+		/* MCoA: Initialize the routing table used by the BCE */
+		if(mcoa_ha_init_rt_table(bce) < 0) {
+ 			free(bce);
+ 			bce = NULL;
+ 			status = IP6_MH_BAS_INSUFFICIENT;
+ 			goto send_nack;
+ 		}
 		if (bcache_add_homereg(bce) < 0) {
 			free(bce);
 			bce = NULL;
 			status = IP6_MH_BAS_INSUFFICIENT;
 			goto send_nack;
 		}
-		if (!(arg->flags & HA_BU_F_SKIP_DAD)) {
+		/* MCoA: Do DAD only if no entries yet for this HoA */		
+		if (!(arg->flags & HA_BU_F_SKIP_DAD) && !bce_exists) {
 			/* Do DAD for home address */
 			if (ndisc_do_dad(home_ifindex, out.dst,
 					 bu_flags & IP6_MH_BU_LLOCAL) < 0) {
-				bcache_delete(out.src, out.dst);
+				bcache_delete(out.src, out.dst, bid);
 				bce = NULL;
 				status =  IP6_MH_BAS_DAD_FAILED;
 				goto send_nack;
 			}
 		}
-		bce = bcache_get(out.src, out.dst);
+		bce = bcache_get(out.src, out.dst, bid);
 		if (!bce) {
 			BUG("BCE deleted before DAD completed!");
 			status =  IP6_MH_BAS_UNSPECIFIED;
@@ -965,6 +1261,7 @@ restart:
 	bce->seqno = seqno;
 	bce->flags = bu_flags;
 	bce->lifetime = lft;
+
 	if (new) {
 		if (tunnel_add(out.src, out.bind_coa, 0, 
 			       home_tnl_ops, &p) < 0) {
@@ -979,7 +1276,8 @@ restart:
 
 		bce->cleanup = home_cleanup;
 
-		if (route_add(bce->link, RT6_TABLE_MIP6,
+		/* MCoA: The route is added in the table given by the BCE */
+		if (route_add(bce->link, bce->table,
 			      RTPROT_MIP, 0, IP6_RT_PRIO_MIP6_OUT,
 			      &bce->our_addr, 128, &bce->peer_addr, 128, 
 			      NULL) < 0) {
@@ -987,16 +1285,23 @@ restart:
 			goto send_nack;
 		}
 
-		if (proxy_nd_start(bce->link, out.dst, out.src,
-				   bu_flags) < 0) {
-			status = IP6_MH_BAS_INSUFFICIENT;
-			goto send_nack;
+		/* MCoA: Do Proxy ND only if no entries yet for this HoA */
+		if (!bce_exists) {
+			if (proxy_nd_start(bce->link, out.dst, 
+					   out.src, bu_flags) < 0) {
+				status = IP6_MH_BAS_INSUFFICIENT;
+				goto send_nack;
+			}
 		}
 		bce->type = BCE_HOMEREG;
 		bcache_complete_homereg(bce);
 	} else {
 		bce->old_coa = bce->coa;
 		bce->coa = *out.bind_coa;
+		if (tsisset(lft)) {
+			bce->bid = bid;
+			bce->priority = bid_priority;
+		}
 		if (tunnel_mod(bce->tunnel, out.src, out.bind_coa, 0,
 			       home_tnl_ops, &p) < 0) { 
 			if (p.ba_status >= IP6_MH_BAS_UNSPECIFIED)
@@ -1006,15 +1311,24 @@ restart:
 			goto send_nack;
 		}
 		/* Now update the MNP list in the BCE */
-		prefix_list_free(&bce->mob_net_prefixes);
-		list_splice(&p.mob_net_prefixes, &bce->mob_net_prefixes);
-
+		/* MCoA: the update is done only if this is not a 
+		 * deregistration BU, otherwise MNPs are erased from the BCE
+		 * (the dereg BU does not have any MNP option), thus there 
+		 * is a problem to update the fwmark MNP rules
+		 */
+		if (tsisset(lft)) {
+			prefix_list_free(&bce->mob_net_prefixes);
+			list_splice(&p.mob_net_prefixes, &bce->mob_net_prefixes);
+		}
 		bcache_update_expire(bce);
 	}
 	/* bce is always valid here */
 	bcache_release_entry(bce);
 	if (!tsisset(lft))
-		bcache_delete(out.src, out.dst);
+		/* MCoA: We delete one specific entry (bid is set) 
+		 * or all entries for this HoA (if bid is set to 0)
+		 */
+		bcache_delete(out.src, out.dst, bid);
 
 	if ((bu_flags & IP6_MH_BU_KEYM) && 
 	    conf.pmgr.use_keymgm(out.dst, out.src))
@@ -1035,12 +1349,16 @@ restart:
 		 * have a binding before sending this Binding Update,
 		 * discard the connections to the home address. */
 	}
- 	if (status < IP6_MH_BAS_UNSPECIFIED && bu_flags & IP6_MH_BU_MR)
+	if ((status < IP6_MH_BAS_UNSPECIFIED 
+	     || status == IP6_MH_BAS_CONFLICT_BINDING)
+	     && bu_flags & IP6_MH_BU_MR)
  		ba_flags |= IP6_MH_BA_MR;
 
 	if (!(arg->flags & HA_BU_F_SKIP_BA))
-		mh_send_ba(&out, status, ba_flags, seqno, &lft, NULL, iif);
-	if (new && tsisset(lft))
+		mh_send_ba(&out, status, ba_flags, seqno, &lft,
+			   bid, bid_priority, NULL, iif);
+	/* MCoA: Start MPA only if no entries yet for this HoA */	
+	if (!bce_exists && new && tsisset(lft))
 		mpd_start_mpa(&bce->our_addr, &bce->peer_addr);
 out:
 	free(arg);
@@ -1060,10 +1378,12 @@ send_nack:
 send_nack:
 	if (bce) {
 		bcache_release_entry(bce);
-		bcache_delete(out.src, out.dst);
+		bcache_delete(out.src, out.dst, bid);
 	}
 	if (!(arg->flags & HA_BU_F_SKIP_BA))
-		mh_send_ba_err(&out, status, 0, seqno, NULL, iif);
+		/* MCoA: Specify the BID and BID priority to the BAck */
+		mh_send_ba_err(&out, status, 0, seqno, bid, 
+			       bid_priority, NULL, iif);
 	goto out;
 }
 
@@ -1089,12 +1409,13 @@ int ha_recv_bu_main(const struct ip6_mh 
 
 	arg = malloc(sizeof(struct ha_recv_bu_args) + len);
 	if (!arg) {
-		if (bce_exists(out.src, out.dst))
-			bcache_delete(out.src, out.dst);
+		if (bce_exists(out.src, out.dst, MCOA_NO_BID))
+			bcache_delete(out.src, out.dst, MCOA_NO_BID);
 
 		if (!(arg->flags & HA_BU_F_SKIP_BA))
 			mh_send_ba_err(&out, IP6_MH_BAS_INSUFFICIENT, 0,
-				       ntohs(bu->ip6mhbu_seqno), NULL, iif);
+				       ntohs(bu->ip6mhbu_seqno), 0, 0,
+				       NULL, iif);
 		return -ENOMEM;
 	}
 	arg->src = *out.src;
@@ -1166,8 +1487,9 @@ int ha_init(void)
 		return -1;
 	if (mpd_ha_init() < 0)
 		return -1;
+	/* MCoA: Rule to the default table (RT6_TABLE_MIP6) */
 	if (rule_add(NULL, RT6_TABLE_MIP6,
-		     IP6_RULE_PRIO_MIP6_FWD, RTN_UNICAST,
+		     IP6_RULE_PRIO_MIP6_FWD, 0, RTN_UNICAST,
 		     &in6addr_any, 0, &in6addr_any, 0, 0) < 0)
 		return -1;
 	icmp6_handler_reg(ND_ROUTER_ADVERT, &ha_ra_handler);
@@ -1185,7 +1507,7 @@ void ha_cleanup(void)
 	pthread_mutex_unlock(&bu_worker_mutex);
 	bcache_flush();
 	rule_del(NULL, RT6_TABLE_MIP6,
-		 IP6_RULE_PRIO_MIP6_FWD, RTN_UNICAST,
+		 IP6_RULE_PRIO_MIP6_FWD, 0, RTN_UNICAST,
 		 &in6addr_any, 0, &in6addr_any, 0, 0);
 	mpd_ha_cleanup();
 	dhaad_ha_cleanup();
diff -r 82fcd4bea972 src/hash.c
--- a/src/hash.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/hash.c	Fri Jan 11 17:02:25 2008 +0100
@@ -47,6 +47,7 @@ struct hash_entry {
 struct hash_entry {
 	struct in6_addr *our_addr; /* pointer to our_addr in data */
 	struct in6_addr *peer_addr; /* pointer to peer_addr in data */
+	uint16_t *bid; /* pointer to bid in data, can be NULL */
 	struct hash_entry *next;
 	void *data;
 };
@@ -78,7 +79,7 @@ static uint32_t calc_hash1(int s, const 
 }
 
 static int match2(struct hash_entry *h, const struct in6_addr *our_addr, 
-		  const struct in6_addr *peer_addr)
+	          const struct in6_addr *peer_addr, uint16_t bid)
 {
 	assert(h);
 	assert(our_addr && h->our_addr);
@@ -89,9 +90,15 @@ static int match2(struct hash_entry *h, 
 	printf("h->peer %s\n", inet_ntop(AF_INET6, h->peer_addr, s, sizeof(s)));
 	printf("our_addr %s\n", inet_ntop(AF_INET6, our_addr, s, sizeof(s)));
 	printf("h->our_addr %s\n", inet_ntop(AF_INET6, h->our_addr, s, sizeof(s)));
+	printf("bid %d\n", bid);
+	if(h->bid != NULL)
+		printf("h->bid %d\n", *(h->bid));
+	else
+		printf("h->bid is NULL\n");
 #endif
 	if (IN6_ARE_ADDR_EQUAL(h->peer_addr, peer_addr) &&
-	    IN6_ARE_ADDR_EQUAL(h->our_addr, our_addr)) {
+	    IN6_ARE_ADDR_EQUAL(h->our_addr, our_addr) && 
+	    (bid == 0 || (h->bid != NULL && bid == *(h->bid)))) {
 		return 1;
 	}
 	return 0;
@@ -99,7 +106,7 @@ static int match2(struct hash_entry *h, 
 }
 
 static int match1(struct hash_entry *h, const struct in6_addr *dummy,
-		  const struct in6_addr *peer_addr)
+		  const struct in6_addr *peer_addr, uint16_t bid)
 {
 	assert(h);
 	assert(h->peer_addr && peer_addr);
@@ -107,8 +114,14 @@ static int match1(struct hash_entry *h, 
 	char s[INET6_ADDRSTRLEN];
 	printf("match1: peer %s\n", inet_ntop(AF_INET6, peer_addr, s, sizeof(s)));
 	printf("h->peer %s\n", inet_ntop(AF_INET6, h->peer_addr, s, sizeof(s)));
+	printf("bid %d\n", bid);
+	if(h->bid != NULL)
+		printf("h->bid %d\n", *(h->bid));
+	else
+		printf("h->bid is NULL\n");
 #endif
-	if (!IN6_ARE_ADDR_EQUAL(h->peer_addr, peer_addr))
+	if (!IN6_ARE_ADDR_EQUAL(h->peer_addr, peer_addr) ||
+	    (bid !=0 && h->bid != NULL && bid != *(h->bid)))
 		return 0;
 	return 1;
 }
@@ -155,7 +168,8 @@ void hash_cleanup(struct hash *h)
 
 void *hash_get(const struct hash *h,
 	       const struct in6_addr *our_addr, 
-	       const struct in6_addr *peer_addr)
+	       const struct in6_addr *peer_addr,
+	       uint16_t bid)
 {
 	struct hash_entry *hptr = NULL;
 	
@@ -165,7 +179,7 @@ void *hash_get(const struct hash *h,
 	hptr = h->hash_buckets[h->calc_hash(h->buckets, our_addr , peer_addr)];
 
 	while(hptr) {
-		if (h->match(hptr, our_addr, peer_addr))
+		if (h->match(hptr, our_addr, peer_addr, bid))
 			return hptr->data;
 		hptr = hptr->next;
 	}
@@ -173,7 +187,8 @@ void *hash_get(const struct hash *h,
 }
 
 int hash_add(const struct hash *h, void *data,
-	     struct in6_addr *our_addr, struct in6_addr *peer_addr)
+	     struct in6_addr *our_addr, struct in6_addr *peer_addr,
+	     uint16_t *bid)
 {
 	struct hash_entry *hptr = NULL, *new;
 	uint32_t hash_ind;
@@ -185,17 +200,19 @@ int hash_add(const struct hash *h, void 
 	assert(peer_addr);
 
 	if ((new = (struct hash_entry *)malloc(sizeof(struct hash_entry))) == NULL) {
-		dbg("out of memeory\n");
+		dbg("out of memory\n");
 		return -ENOMEM;
 	}
 	new->our_addr = our_addr;
 	new->peer_addr = peer_addr;
 	new->data = data;
+	new->bid = bid;
 	hash_ind  = h->calc_hash(h->buckets, our_addr, peer_addr);
 	hptr = h->hash_buckets[hash_ind];
 	if (hptr) {
 		while (hptr->next){
-			if (h->match(hptr, our_addr, peer_addr)) {
+			if (h->match(hptr, our_addr, peer_addr, 
+				     (bid) ? (*bid) : 0)) {
 				free(new);
 				return -EEXIST;
 			}
@@ -231,9 +248,35 @@ int hash_iterate(const struct hash *h, i
 	return 0;
 }
 
+int hash_iterate_in(const struct hash *h, 
+		    const struct in6_addr *peer_addr, 
+		    int (*func)(void *, void *), 
+		    void *arg)
+{
+	int err = 0;
+	int i;
+	struct hash_entry *hptr, *nptr;
+
+	assert(func);
+	
+	for (i=0; i < h->buckets; i++) {
+		if((hptr = h->hash_buckets[i]) != NULL) {
+			while(hptr) {
+				nptr = hptr->next;
+				if (IN6_ARE_ADDR_EQUAL(hptr->peer_addr, peer_addr)
+				    && (err = func(hptr->data, arg)))
+					return err;
+				hptr = nptr;
+			}
+		}
+	}
+	return 0;
+}
+
 void hash_delete(const struct hash *h,
 		 const struct in6_addr *our_addr,
-		 const struct in6_addr *peer_addr)
+		 const struct in6_addr *peer_addr,
+		 uint16_t bid)
 {
 	struct hash_entry *hptr, *pptr, *head;
 	int hash_ind;
@@ -247,7 +290,7 @@ void hash_delete(const struct hash *h,
 	
 	pptr = hptr = head;
 	while (hptr) {
-		if (h->match(hptr, our_addr, peer_addr)){
+		if (h->match(hptr, our_addr, peer_addr, bid)){
 			if (hptr != head) 
 				pptr->next = hptr->next;
 			else {
diff -r 82fcd4bea972 src/hash.h
--- a/src/hash.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/hash.h	Fri Jan 11 17:02:25 2008 +0100
@@ -20,7 +20,9 @@ struct hash {
 	int buckets;
 	int type; 
 	uint32_t (*calc_hash)(int, const struct in6_addr *, const struct in6_addr *);
-	int (*match)(struct hash_entry *, const struct in6_addr *, const struct in6_addr *);
+	int (*match)(struct hash_entry *, const struct in6_addr *, 
+		     const struct in6_addr *, uint16_t);
+
 	struct hash_entry **hash_buckets;
 };
 
@@ -37,19 +39,24 @@ int hash_init(struct hash *h, int type, 
  */
 void hash_cleanup(struct hash *h);
 /*
- *  Get data stored in a hash entry based on one or two addresses, depending on type of hash
+ * Get data stored in a hash entry based on one or two addresses and the bid,
+ * depending on type of hash. bid=0 means we do not use bid as a search key.
  */
 void *hash_get(const struct hash *h,
 	       const struct in6_addr *our_addr, 
-	       const struct in6_addr *peer_addr) ;
+	       const struct in6_addr *peer_addr,
+	       uint16_t bid);
 
 /* Iterate through the hash and call func for every entry */
 
 int hash_iterate(const struct hash *h, int (*func)(void *data, void *arg), void *arg);
+int hash_iterate_in(const struct hash *h, const struct in6_addr *peer_addr, 
+		    int (*func)(void *, void *), void *arg);
 
 /* Add a hash entry to hash */		 
 int hash_add(const struct hash *h, void  *data,
-	     struct in6_addr *our_addr, struct in6_addr *peer_addr);
+	     struct in6_addr *our_addr, struct in6_addr *peer_addr,
+	     uint16_t *bid);
 
 /*
  *Delete entry from hash
@@ -57,6 +64,7 @@ int hash_add(const struct hash *h, void 
 
 void hash_delete(const struct hash *h,
 		 const struct in6_addr *our_addr, 
-		 const struct in6_addr *peer_addr);
+		 const struct in6_addr *peer_addr,
+		 uint16_t bid);
 
 #endif /* _HASH_H */
diff -r 82fcd4bea972 src/mh.c
--- a/src/mh.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mh.c	Fri Jan 11 17:02:25 2008 +0100
@@ -77,6 +77,7 @@ int mh_opts_dup_ok[] = {
 	0, /* Nonce Index */
 	0, /* Binding Auth Data */
 	1, /* Mobile Network Prefix */
+	1  /* Binding Unique Identifier */
 };
 
 #define __MH_SENTINEL (IP6_MH_TYPE_MAX + 1)
@@ -443,6 +444,41 @@ int mh_create_opt_mob_net_prefix(struct 
 	return 0;
 }
 
+/* MCoA
+ * mh_create_opt_bid - Create a Binding Unique Identifier Option
+ * MCoA TODO1: need to be adapted for BULK registration
+ */
+int mh_create_opt_bid(struct iovec *iov, uint16_t bid, 
+		      uint8_t priority, uint8_t bid_flags)
+{
+	int optlen = sizeof(struct ip6_mh_opt_bid);
+	struct ip6_mh_opt_bid *opt_bid;
+	uint8_t *data;
+
+	iov->iov_base = malloc(optlen);
+	iov->iov_len = optlen;
+
+	if (iov->iov_base == NULL)
+		return -ENOMEM;
+
+	memset(iov->iov_base, 0, iov->iov_len);
+	data = (uint8_t *)iov->iov_base;
+	
+	opt_bid = (struct ip6_mh_opt_bid *)data;
+
+	opt_bid->ip6mobid_type = IP6_MHOPT_BID;
+	opt_bid->ip6mobid_len = 4;
+	opt_bid->ip6mobid_bid = htons(bid);
+	opt_bid->ip6mobid_priority = priority;
+	opt_bid->ip6mobid_reserved |= bid_flags;
+
+	data += sizeof(struct ip6_mh_opt_bid);
+	MDBG("BUI sub-option created with BID = %d and priority %d\n", 
+	     bid, priority);
+
+	return 0;
+}
+
 static size_t mh_length(struct iovec *vec, int count)
 {
 	size_t len = 0;
@@ -487,6 +523,9 @@ static int mh_try_pad(const struct iovec
 		case IP6_MHOPT_MOB_NET_PRFX:
 			pad = optpad(8, 4, len); /* 8n+4 */
 			break;
+		case IP6_MHOPT_BID:
+			pad = optpad(2, 0, len); /* 2n */
+			break;
 		}
 		if (pad > 0) {
 			create_opt_pad(&out[n++], pad);
@@ -497,9 +536,10 @@ static int mh_try_pad(const struct iovec
 		out[n].iov_base = in[m].iov_base;
 		n++;
 	}
-	if (count == 1) {
+	if (count == 1 || len%8 != 0) {
 		pad = optpad(8, 0, len);
 		create_opt_pad(&out[n++], pad);
+		MDBG("Added %d bytes for padding\n", pad);
 	}
 
 	return n;
@@ -984,11 +1024,14 @@ void mh_send_brr(struct in6_addr *mn_add
 
 void mh_send_ba(const struct in6_addr_bundle *addrs, uint8_t status,
 		uint8_t flags, uint16_t sequence, 
-		const struct timespec *lifetime, const uint8_t *key, int iif)
+		const struct timespec *lifetime, 
+		const uint16_t bid,
+		const uint8_t priority,
+		const uint8_t *key, int iif)
 {
 	int iovlen = 1;
 	struct ip6_mh_binding_ack *ba;
-	struct iovec mh_vec[2];
+	struct iovec mh_vec[3];
 
 	MDBG("status %d\n", status);
 
@@ -1012,6 +1055,9 @@ void mh_send_ba(const struct in6_addr_bu
 	}
 	if (key)
 		mh_create_opt_auth_data(&mh_vec[iovlen++]);
+	/* MCoA: Create Binding Unique Identifier Option if needed */
+	if (bid) 
+		mh_create_opt_bid(&mh_vec[iovlen++], bid, priority, 0);
 	mh_send(addrs, mh_vec, iovlen, key, iif);
 	free_iov_data(mh_vec, iovlen);
 }
@@ -1058,8 +1104,11 @@ int mh_bu_parse(struct ip6_mh_binding_up
 			return -1;
 		if (!IN6_ARE_ADDR_EQUAL(out_addrs->bind_coa, peer_addr)) {
 			/* check that there is no circular reference */
-			if (bce_exists(our_addr, out_addrs->bind_coa))
+			if (bce_exists(our_addr, out_addrs->bind_coa, 
+				       MCOA_NO_BID)) {
+				MDBG("Circular reference found in BC\n");
 				return -1;
+			}
 			tssetsec(*lifetime, ntohs(bu->ip6mhbu_lifetime) << 2);
 		}
 	}
diff -r 82fcd4bea972 src/mh.h
--- a/src/mh.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/mh.h	Fri Jan 11 17:02:25 2008 +0100
@@ -10,7 +10,7 @@
 
 /* If new types or options appear, these should be updated. */
 #define IP6_MH_TYPE_MAX IP6_MH_TYPE_BERROR
-#define IP6_MHOPT_MAX IP6_MHOPT_MOB_NET_PRFX
+#define IP6_MHOPT_MAX IP6_MHOPT_BID
 
 struct in6_addr_bundle {
 	struct in6_addr *src;
@@ -43,14 +43,20 @@ void mh_send_ba(const struct in6_addr_bu
 void mh_send_ba(const struct in6_addr_bundle *addrs, uint8_t status, 
 		uint8_t flags, uint16_t sequence, 
 		const struct timespec *lifetime,
+		const uint16_t bid,
+		const uint8_t priority,
 		const uint8_t *key, int iif);
 
 static inline void mh_send_ba_err(const struct in6_addr_bundle *addrs,
 				  uint8_t status, uint8_t flags,
-				  uint16_t seqno, const uint8_t *key, int iif)
+				  uint16_t seqno, 
+				  const uint16_t bid,
+				  const uint8_t priority,
+				  const uint8_t *key, int iif)
 {
 	struct timespec zero = { 0, 0 };
-	mh_send_ba(addrs, status, flags, seqno, &zero, key, iif);
+	mh_send_ba(addrs, status, flags, seqno, &zero, 
+		   bid, priority, key, iif);
 }
 
 void mh_send_be(struct in6_addr *dst,
@@ -78,6 +84,9 @@ struct list_head;
 
 int mh_create_opt_mob_net_prefix(struct iovec *iov, int mnp_count,
 				 struct list_head *mnps);
+
+int mh_create_opt_bid(struct iovec *iov, uint16_t bid, uint8_t priority, 
+		      uint8_t bid_flags);
 
 static inline void *mh_opt(const struct ip6_mh *mh,
 			   const struct mh_options *mh_opts, uint8_t type)
